
from ._start import grammar, YaccProduction, context


# catch all ASM as it, no processing them
@grammar
def lineAsm(p: YaccProduction):
    '''line : ID asmValideInstructions EndLine'''
    p[0] = p[1] + ' ' + p[2]


@grammar
def lineEnd(p: YaccProduction):
    '''line : ID EndLine'''
    if (p[1] != 'end'):
        raise SystemExit('instruction "{}" is not "end" and alone'.format(p[1]))
    p[0] = p[1]


@grammar
def asmFollowInstructions_one(p: YaccProduction):
    '''asmValideInstructions : info'''
    p[0] = str(p[1])


@grammar
def asmFollowInstructions_many(p: YaccProduction):
    '''asmValideInstructions : asmValideInstructions info'''
    p[0] = p[1] + ' ' + str(p[2])


@grammar
def info_id(p: YaccProduction):
    '''info : ID'''
    p[0] = p[1] if not context.fun.inFunScope else context.fun.scopeId(p[1])

@grammar
def info(p: YaccProduction):
    '''info : Number
            | String
            | ArobasedInfo
    '''
    p[0] = p[1]
